package org.rlcommunity.agents.random;

import java.io.*;
import java.net.URL;
import java.util.Random;

import rlVizLib.general.ParameterHolder;
import rlVizLib.general.hasVersionDetails;

import org.rlcommunity.rlglue.codec.AgentInterface;
import org.rlcommunity.rlglue.codec.taskspec.TaskSpec;
import org.rlcommunity.rlglue.codec.taskspec.ranges.AbstractRange;
import org.rlcommunity.rlglue.codec.taskspec.ranges.DoubleRange;
import org.rlcommunity.rlglue.codec.taskspec.ranges.IntRange;
import org.rlcommunity.rlglue.codec.types.Action;
import org.rlcommunity.rlglue.codec.types.Observation;
import org.rlcommunity.rlglue.codec.util.AgentLoader;
import rlVizLib.messaging.NotAnRLVizMessageException;
import rlVizLib.messaging.agent.AgentMessageParser;
import rlVizLib.messaging.agent.AgentMessages;
import rlVizLib.messaging.agentShell.TaskSpecResponsePayload;
import rlVizLib.messaging.interfaces.HasImageInterface;
import java.lang.reflect.Array;
import java.util.Vector;
public class IMAgent implements AgentInterface,HasImageInterface {

    private int numsalient, numstates, numactions, numlabels, num_max_states;
    private boolean waslastactionrandom;
    private Action action;
    private Random random = new Random();
    TaskSpec TSO = null;
    private int num_iter;
    private int iter_limit;
    private int laststate;
    private int lastaction;
    private double extrinsic_r, intrinsic_r;
    private Observation lastobservation;
    private double alpha, gamma, tau, epsilon;
    private boolean[] skill_list;
    private boolean[][] I;
    private int[][] beta;
    private double[][][] P, QO, QA;
    private double[][] R, QBA, QBO;
    private double[] totalreward;
    private int[] totalhits;
    BufferedWriter stats, hits;
    private Vector<Observation> states =new Vector<Observation>();
    public void fillRandomProbs(double[] P){
	for(int i=0;i<P.length;i++){
	    //P[i]=random.nextDouble();
	    P[i]=1/P.length;
	}
/*	double sum=0;
	for(int i=0;i<P.length-1;i++){
	    P[i]/=P.length;
	    sum+=P[i];
	}
	P[P.length-1]=1-sum;*/
    }
    public void fill3DDoubleArrayRandomProb(double[][][] P){
	for(int i=0;i<P.length;i++){
		for(int j=0;j<P[i].length;j++){
			fillRandomProbs(P[i][j]);
		}
	}
    }
    public boolean areSameState(Observation a, Observation b){
	for(int i=0;i<7;i++)	if(a.intArray[i]!=b.intArray[i])return false;
	return true;
    }
    public int getState(Observation o){
	for(int i=0;i<numstates;i++){
	    if(areSameState(states.get(i),o))return i;
	}
	//System.out.println("Adding new observation");
	states.add(o);
	numstates++;
	if(numstates >num_max_states){
		//System.out.println("Increasing size of data structures");
		num_max_states*=2;
		for(int i=0;i<numsalient;i++){
			I[i]=(boolean[])arrayGrow(I[i]);
			R[i]=(double[])arrayGrow(R[i]);
		}
		for(int i=0;i<numsalient;i++)beta[i]=(int[])arrayGrow(beta[i]);
		for(int j=0;j<numsalient;j++){
			for(int i=0;i<num_max_states/2;i++)P[j][i]=(double[])arrayGrow(P[j][i]);
			P[j]=(double[][])arrayGrow(P[j]);
			for(int i=num_max_states/2;i<num_max_states;i++){
				P[j][i]=new double[num_max_states];
				fillRandomProbs(P[j][i]);
			}
		}
		QBA=(double[][])arrayGrow(QBA);
		QBO=(double[][])arrayGrow(QBO);
		for(int i=num_max_states/2;i<num_max_states;i++){
		    QBA[i]=new double[numactions];
		    QBO[i]=new double[numactions];
		}
		//System.out.println("Size of QBA "+Array.getLength(QBA));
		for(int j=0;j<numsalient;j++){
			QA[j]=(double[][])arrayGrow(QA[j]);
			//System.out.println("Size of x "+Array.getLength(QA[j]));
			for(int i=num_max_states/2;i<num_max_states;i++)QA[j][i]=new double[numactions];
		}

		for(int j=0;j<numsalient;j++){
			QO[j]=(double[][])arrayGrow(QO[j]);
			for(int i=num_max_states/2;i<num_max_states;i++)QO[j][i]=new double[numsalient];
		}
	}
	return numstates-1;
    }
/*
I=new boolean[numsalient][numstates];
        beta=new int[numsalient][numstates];
        P=new double[numsalient][numstates][numstates];
        R=new double[numsalient][numstates];
        QBA=new double[numstates][numactions];
        QBO=new double[numstates][numsalient];
        QA=new double[numsalient][numstates][numactions];
        QO=new double[numsalient][numstates][numsalient];

*//*    public int getState(Observation o){
	int stateval;//= o.intArray[0]+o.intArray[1]*numlabels
		//	+o.intArray[2]*numlabels*numlabels+o.intArray[4]*numlabels*numlabels*2;
			//+o.intArray[4]*numlabels*numlabels*4+o.intArray[5]*numlabels*numlabels*8
			//+o.intArray[6]*numlabels*numlabels*16)%100;
	
	return stateval;//random.nextInt(100);
    }*/
    public boolean isSalient(Observation o){
	int which=whichSalient(o);
	return (which>=0);
    }
    public int whichSalient(Observation o){
	if(o.intArray[3]==1)return 0;
	if(o.intArray[4]==1 && lastobservation.intArray[4]==0)return 0;
	if(o.intArray[4]==0 && lastobservation.intArray[4]==1)return 1;
	if(o.intArray[5]==1 && lastobservation.intArray[5]==0)return 1;
	if(o.intArray[5]==0 && lastobservation.intArray[5]==1)return 4;
	if(o.intArray[6]==1 && lastobservation.intArray[6]==0)return 5;
	return -1;
    }
    public int getGreedyAction(int skill, int state){
	int max=0;
	for(int i=1;i<numactions;i++){
	    if(QA[skill][state][i]>QA[skill][state][max])max=i;
	}
	return max;
	//Future work: build a list of equal valued QO and select randomly from that
    }
    public double sum(int state,int nextstate, int i, int j){
	double s=0;
	for(int k=0;k<numstates;k++){
	    s+=P[j][k][state]*(beta[i][k]*terminal_value(i, nextstate)+(1-beta[i][k])*maxQOA(k, i));
	}
	return s;
    }
    public static Object arrayGrow(Object a) { 
	Class cl = a.getClass(); 
	if (!cl.isArray()) return null; 
	int length = Array.getLength(a);
	int newLength = length * 2;
	Class componentType = a.getClass().getComponentType();
	Object newArray = Array.newInstance(componentType, newLength);
	System.arraycopy(a, 0, newArray, 0, length);
	return newArray;
    }
    public double maxQOA(int state, int i){
	int max1=0, max2=0;
	for(int k=1;k<numactions;k++){
	    if(QA[i][state][k]>QA[i][state][max1])max1=k; 		
	}
	for(int j=1;j<numsalient;j++){
	    if(QO[i][state][j]>QO[i][state][max2])max2=j;
	}
	if(QA[i][state][max1]>QA[i][state][max2])return QA[i][state][max1];
	return QO[i][state][max2];
    }
    public double maxQB(int state){
	int max1=0, max2=0;
        for(int k=1;k<numactions;k++){
            if(QBA[state][k]>QBA[state][max1])max1=k;
        }
        for(int j=1;j<numsalient;j++){
            if(QBO[state][j]>QBO[state][max2])max2=j;
        }
        if(QBA[state][max1]>QBO[state][max2])return QBA[state][max1];
        return QBO[state][max2];
    }
    public double smdp(int state, int i){
	int s=0;
	for(int j=0;j<numstates;j++){
	    s+=P[i][j][state]*maxQB(j);
	}
	return s;
    }
    public double terminal_value(int op, int state){
	return 1+maxQB(state);
    }
    public int EpsilonGreedySelect(int state){
	double d= random.nextDouble();
	if(d<=epsilon){
		//choose random action
		waslastactionrandom=true;
		return random.nextInt(numactions);
	}
	else {
	    waslastactionrandom=false;
	    int max1=0, max2=0, count=0,k=0;
            for(k=1;k<numactions;k++){
                if(QBA[state][k]>QBA[state][max1]){
			max1=k;
			count=1;
		}
		if(QBA[state][k]==QBA[state][max1]){
		    count++;
		}
            }
	    if(count>0)count=random.nextInt(count);
	    k=1;
	    while(count>0){
		if(QBA[state][k]==QBA[state][max1]){
		    count--;
		    max1=k;
		}
		k++;
	    }
	//    return max1;
            for(int j=1;j<numsalient;j++){
                if(QBO[state][j]>QBO[state][max2])max2=j;
            }
            if(QBA[state][max1]>=QBO[state][max2])return max1;
	    //return max1;
	//}
	    else {
		//look for max under QA, QO	
		int selectedoption=max2;
		max1=0;
		for(k=1;k<numactions;k++){
		    if(QA[selectedoption][state][k]>QA[selectedoption][state][max1]){
			max1=k;
			count=1;
		    }
		    if(QA[selectedoption][state][k]==QA[selectedoption][state][max1]){
		    	count++;
		    }
            	}
	    	if(count>0)count=random.nextInt(count);
	    	    k=1;
	    	while(count>0){
		    if(QA[selectedoption][state][k]==QA[selectedoption][state][max1]){
		    	count--;
		    	max1=k;
		    }
		    k++;
	    	}
	   		// return max1;
	    	max2=0;
            	for(int j=1;j<numsalient;j++){
                    if(QO[selectedoption][state][j]>QO[selectedoption][state][max2])max2=j;
            	}
            	if(QA[selectedoption][state][max1]>=QO[selectedoption][state][max2])return max1;
	    	else{
		    System.out.println("Not too sure about the action chosen");
		    return max1;	//doing what QB says. is this right?
	    	}
	    }
	}
    }	
    public IMAgent() {
        this(getDefaultParameters());
    }

    public IMAgent(ParameterHolder p) {
        super();
	numlabels=6;
	num_max_states=2;//numlabels*numlabels*numlabels*2;//16;
	numstates=0;
	numactions=10;
	numsalient=2;
	alpha=0.2d;
	tau=1;
	gamma=1;
	epsilon=0.5;
	iter_limit=200;
	skill_list=new boolean[numsalient];
	I=new boolean[numsalient][num_max_states];
	beta=new int[numsalient][num_max_states];
	P=new double[numsalient][num_max_states][num_max_states];
	fill3DDoubleArrayRandomProb(P);
	R=new double[numsalient][num_max_states];
	QBA=new double[num_max_states][numactions];
	QBO=new double[num_max_states][numsalient];
	QA=new double[numsalient][num_max_states][numactions];
	QO=new double[numsalient][num_max_states][numsalient];
	totalreward=new double[numsalient];
	totalhits=new int[numsalient];
	try{
		stats=new BufferedWriter(new FileWriter("stats.txt"));
		hits=new BufferedWriter(new FileWriter("hits.txt"));
		//stats.write("Output file\n");
		//stats.close();
	}
	catch(Exception e){
		System.out.println("Error creating output buffer");
	}
    }
    
    
    //Need to do something about this: This should say that all task specs are NOT OKAY.
    public static TaskSpecResponsePayload isCompatible(ParameterHolder P, String TaskSpec){
        return new TaskSpecResponsePayload(false,"");
    }

     public static ParameterHolder getDefaultParameters() {
        ParameterHolder p = new ParameterHolder();
        rlVizLib.utilities.UtilityShop.setVersionDetails(p, new DetailsProvider());
        return p;
    }

    public static void main(String[] args){
        AgentLoader L=new AgentLoader(new IMAgent());
        L.run();
    }
    public void agent_init(String taskSpec) {
        TSO = new TaskSpec(taskSpec);

        //Do some checking on the ranges here so we don't feel bad if we crash later for not checking them.
        for (int i = 0; i < TSO.getNumDiscreteActionDims(); i++) {
            AbstractRange thisActionRange = TSO.getDiscreteActionRange(i);

            if (thisActionRange.hasSpecialMinStatus() || thisActionRange.hasSpecialMaxStatus()) {
                System.err.println("The random agent does not know how to deal with actions that are unbounded or unspecified ranges.");
            }
        }
        for (int i = 0; i < TSO.getNumContinuousActionDims(); i++) {
            AbstractRange thisActionRange = TSO.getContinuousActionRange(i);

            if (thisActionRange.hasSpecialMinStatus() || thisActionRange.hasSpecialMaxStatus()) {
                System.err.println("The random agent does not know how to deal with actions that are unbounded or unspecified ranges.");
            }
        }

        action = new Action(TSO.getNumDiscreteActionDims(), TSO.getNumContinuousActionDims());
    }
    public void dump(double[][] QBA){
	for(double[] x:QBA){
		for(double y:x)
			System.out.print(y+" ");
		System.out.println();
	}
    }
    public Action agent_start(Observation o) {
        laststate=getState(o);
	//System.out.println("State "+laststate);
	lastobservation=o;
	waslastactionrandom=true;
	action.intArray[0]=random.nextInt(numactions);
	lastaction=action.intArray[0];
	//System.out.println("Action chosen : "+action.intArray[0]);
	num_iter=0;
	return action;
    }
    public boolean isGreedy(int action, int option, int state){
	int max=0;
	for(int i=0;i<numactions;i++)
		if(QA[option][state][action]<QA[option][state][i])return false;
	return true;
    }
    public Action agent_step(double arg0, Observation o) {
        num_iter++;
//	System.out.print("Agent deciding...................");
	int state=getState(o);
	//System.out.print("State "+state);
	int e=-1;
	double nextextrinsic_r=arg0;
	double nextintrinsic_r;
	int nextaction;
	if(isSalient(o)){
	    e=whichSalient(o);
	    System.out.println("Salient state "+e+" reached!");
	    if(!skill_list[e]){
		System.out.println("adding skill "+e);
		skill_list[e]=true;
	    }
	    I[e][laststate]=true;
	    beta[e][state]=1;
	    //System.out.println("Skill updated");
	    nextintrinsic_r = tau*(1-P[e][state][laststate]);
	    if(nextintrinsic_r < 0.001)nextintrinsic_r=0;
	    P[e][state][laststate]=(1-alpha)*P[e][state][laststate]+alpha*gamma;
	    R[e][state]=(1-alpha)*R[e][state]+alpha*(nextextrinsic_r);
	    //System.out.println("Got intrinsic reward\n");
	    System.out.println("intrinsic reward received "+nextintrinsic_r+" "+P[e][state][laststate]);
	    totalreward[e]+=nextintrinsic_r;
	    totalhits[e]++;
	}
	else
	    nextintrinsic_r=0;
	//System.out.println("reward decided");
	for (int i=0;i<numsalient;i++){
	    if(!skill_list[i])continue;
	    if(I[i][state]) I[i][laststate]=true;
	    if(isGreedy(lastaction,i,laststate)){
		for(int x=0;x<numstates;x++){
		    P[i][x][laststate]=(1-alpha)*P[i][x][laststate]
			+alpha*gamma*(	(1-beta[i][state])*(P[i][x][state])	+	beta[i][state]*(x==state?1:0));
		    if(P[i][x][laststate]!=0){
			System.out.print("Changed e:"+ e + " x "+x+" laststate "+laststate+" state "+state + " beta " +beta[i][state]);
		    }
		}
		R[i][laststate]=(1-alpha)*R[i][laststate]+alpha*(extrinsic_r+gamma*(1-beta[i][state])*R[i][state]);
	    }
	}
	//System.out.println("Checkpoint 1");
	QBA[laststate][lastaction]=(1-alpha)*QBA[laststate][lastaction]+alpha*(extrinsic_r+nextintrinsic_r+gamma*maxQB(state));
	//System.out.println("Checkpoint 1.5");
	for(int i=0;i<numsalient;i++){
	    if(!skill_list[i])continue;
	    QBO[laststate][i]=(1-alpha)*QBO[laststate][i]+alpha*(R[i][laststate]+smdp(laststate, i));
	}
	//System.out.println("Checkpoint 2");
	for(int i=0;i<numsalient;i++){
	
	//System.out.println("Checkpoint 2.01:"+i);
	    if(!I[i][laststate])continue;
		//System.out.println("Checkpoint 2.05:"+i);
	    QA[i][laststate][lastaction]=(1-alpha)*QA[i][laststate][lastaction]+alpha*(extrinsic_r+gamma*(beta[i][state]*terminal_value(i, state)+(1-beta[i][state])*maxQOA(state, i)));
	
	//System.out.println("Checkpoint 2.1:"+i);
	
	    for (int j=0; j<numsalient; j++){
		if(!skill_list[j] || i==j || !I[j][laststate] ) continue;
		QO[i][laststate][j]=(1-alpha)*QO[i][laststate][j]+alpha*(R[j][laststate]+sum(laststate,state,i,j));
	    }
	}

	//System.out.println("Checkpoint 3");
	nextaction=EpsilonGreedySelect(state);
	//convert to Action object
	//action.intArray[0]=random.nextInt(numactions);
	action.intArray[0]=nextaction;
	//System.out.println("Action chosen "+action.intArray[0]);
	laststate=state;
	lastobservation=o;
	if(num_iter==iter_limit-1)
		agent_end(0);	//Doesn't really end the agent: just prints out the stats at the end of iter_limit iterations
        //System.out.println("Iter:"+num_iter);
	if(num_iter%10==0){
		//System.out.println("Q-values");
		//dump(QBA);
		//System.out.println("State transition probabilities");
		//dump(P[0]);
	}
	lastaction=nextaction;
	intrinsic_r=nextintrinsic_r;
	extrinsic_r=nextextrinsic_r;
	return action;
    }

    public void agent_end(double reward) {
	try{
		for(int i=0;i<numsalient;i++){
		    stats.write(totalreward[i]+ " ");
		    hits.write(totalhits[i]+ " ");
		}
		stats.write("\n");
		hits.write("\n");
		//dump(QBA);
		//dump(P[1]);
		//System.out.println("wrote to file");
		//stats.close();
	}
	catch(Exception e){
		System.out.println("Error writing to file");
	}
	
	for(int i=0;i<numsalient;i++){
	    System.err.print(totalreward[i]+ " ");
	    totalreward[i]=0;
	    totalhits[i]=0;
	}
	System.err.println();
	num_iter=0;
    }

    private void setRandomActions(Action action) {
        for (int i = 0; i < TSO.getNumDiscreteActionDims(); i++) {
            IntRange thisActionRange = TSO.getDiscreteActionRange(i);
            action.intArray[i] = random.nextInt(thisActionRange.getRangeSize()) + thisActionRange.getMin();
        }
        for (int i = 0; i < TSO.getNumContinuousActionDims(); i++) {
            DoubleRange thisActionRange = TSO.getContinuousActionRange(i);
            action.doubleArray[i] = random.nextDouble() * (thisActionRange.getRangeSize()) + thisActionRange.getMin();
        }
    }

    public void agent_cleanup() {
        try{
		stats.close();
		hits.close();
	}
	catch(Exception e){
		System.out.println("Error closing file");
	}
    }

    public String agent_message(String theMessage) {
        AgentMessages theMessageObject;
        try {
            theMessageObject = AgentMessageParser.parseMessage(theMessage);
        } catch (NotAnRLVizMessageException e) {
            System.err.println("Someone sent random agent a message that wasn't RL-Viz compatible");
            return "I only respond to RL-Viz messages!";
        }

        if (theMessageObject.canHandleAutomatically(this)) {
            return theMessageObject.handleAutomatically(this);
        }
        System.err.println("Didn't know how to respond to message.");
        return null;
    }

    public URL getImageURL() {
        return this.getClass().getResource("/images/randomagent.png");
    }

}

/**
 * This is a little helper class that fills in the details about this environment
 * for the fancy print outs in the visualizer application.
 * @author btanner
 */
class DetailsProvider implements hasVersionDetails {

    public String getName() {
        return "Intrinsically Motivated Agent 1.0";
    }

    public String getShortName() {
        return "IM Agent";
    }

    public String getAuthors() {
        return "Nitish Srivastava";
    }

    public String getInfoUrl() {
        return "http://home.iitk.ac.in/~nitishs/CS365/project/IMAgentJava";
    }

    public String getDescription() {
        return "RL-Library Java Version of an Intrinsically Motivated agent.  Can handle discrete actions and observations.";
    }
}

