import org.rlcommunity.rlglue.codec.RLGlue;
import org.rlcommunity.rlglue.codec.types.*;
import java.io.IOException;

public class SampleExperiment
{
	protected static final int kNumEpisodes = 200;
	protected static int rlNumSteps[];
	protected static double rlReturn[];
	
	//cutoff
	protected static int maxStepsPerEpisode=200;
	

	protected static void run(int numEpisodes) throws IOException
	{
		/*run for num_episode number of episodes and store the number of steps and return from each episode*/        	
		for(int x = 0; x < numEpisodes; ++x) {
			System.err.println("Episode: "+(x+1));
			RLGlue.RL_episode(maxStepsPerEpisode);
			System.out.println("\t steps: "+RLGlue.RL_num_steps()); 
			rlNumSteps[x] = RLGlue.RL_num_steps();
			rlReturn[x] = RLGlue.RL_return();
		}
	}

	public static void main(String [] args) throws IOException {
		double avgSteps = 0.0;
		double avgReturn = 0.0;

		rlNumSteps = new int[SampleExperiment.kNumEpisodes];
		rlReturn = new double[SampleExperiment.kNumEpisodes];

		RLGlue.RL_init();

		System.out.println("Running: "+kNumEpisodes+" with a cutoff each of: "+maxStepsPerEpisode+" steps.");
		
		run(kNumEpisodes);
		RLGlue.RL_cleanup();
		
		/*add up all the steps and all the returns*/
		for (int i = 0; i < SampleExperiment.kNumEpisodes; ++i) {
		    avgSteps += rlNumSteps[i];
		    avgReturn += rlReturn[i];
		}
		
		/*average steps and returns*/
		avgSteps /= (double)SampleExperiment.kNumEpisodes;
		avgReturn /= (double)SampleExperiment.kNumEpisodes;
		
		/*print out results*/
		System.out.println("\n-----------------------------------------------\n");
		System.out.println("Number of episodes: " + SampleExperiment.kNumEpisodes);
		System.out.println("Average number of steps per episode: " +  avgSteps);
		System.out.println("Average return per episode: " + avgReturn);
		System.out.println("-----------------------------------------------\n");
	}   
}
